unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,ShellApi, OleCtrls, voicerlibLib_TLB, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    cmdIniciaDriver: TButton;
    CriaThread: TButton;
    cmdFinalizaDriver: TButton;
    DestroiThread: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    voicerlib1: Tvoicerlib;
    Label3: TLabel;
    txtPorta: TEdit;
    txtTempoSilencio: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    txtLimiar: TEdit;
    Image1: TImage;
    Button1: TButton;
    Panel3: TPanel;
    lblStatus: TLabel;
    lblStatus1: TLabel;
    LimpaLog: TButton;
    procedure CriaThreadClick(Sender: TObject);
    procedure DestroiThreadClick(Sender: TObject);
    procedure LimpaLogClick(Sender: TObject);
    procedure cmdIniciaDriverClick(Sender: TObject);
    procedure cmdFinalizaDriverClick(Sender: TObject);
    procedure voicerlib1RingDetected(ASender: TObject; Port: Smallint);
    procedure voicerlib1AfterPickup(ASender: TObject; Port: Smallint);
    procedure voicerlib1PlayStop(ASender: TObject; Port,
      StopStatus: Smallint);
    procedure voicerlib1RecordStop(ASender: TObject; Port,
      StopStatus: Smallint);
    procedure voicerlib1BusyDetected(ASender: TObject; Port: Smallint);
    procedure voicerlib1Recording(ASender: TObject; Port: Smallint;
      ElapsedTime: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure voicerlib1CallerID(ASender: TObject; Port: Smallint;
      const Number: WideString);
    procedure voicerlib1E1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
      AlarmData: Smallint);
    procedure voicerlib1E1StateChange(ASender: TObject; Port,
      State: Smallint);
    procedure voicerlib1SilenceDetected(ASender: TObject; Port,
      State: Smallint);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  x: integer;
  nTotalPortas : Integer;
  nTotalPlacas : Integer;
  nPorta : Integer;
  nFlag : Integer;
  sReturn    : array [0..255] of Char;

implementation

{$R *.dfm}

//**********************************************************
//Esta procedure coloca na tela os estados do programa
//com hora e a porta
//**********************************************************
procedure MostraStatus(nPorta: integer; sMess: string);
var
  sMsg: string;
begin
  if (nPorta > 0) then
    sMsg := '<' + TimeToStr(Time) + '> - (Porta ' + IntToStr(nPorta) + ') - ' +sMess
  else
    sMsg := '<' + TimeToStr(Time) + '> - ' + sMess;
  Form1.Memo1.Lines.Add(sMsg);
end;

//**********************************************************
//Cria uma thread de tratamento E1 para cada canal da placa
//**********************************************************
procedure TForm1.CriaThreadClick(Sender: TObject);
var
  nRet,i,j,k : Integer;
begin
  try
    for j:=1 to voicerlib1.GetPortsCount do
    begin
      //Cria thread do protocolo R2D
      nRet := voicerlib1.CreateE1Thread(j);

      case nRet of
        DG_EXIT_SUCCESS:
          MostraStatus(j,'Thread E1 iniciada com sucesso');

        DG_ERROR_DRIVER_CLOSED:
          MostraStatus(j,'O driver no foi iniciado');

        DG_ERROR_THREAD_ALREADY_RUNNING:
          MostraStatus(j,'A thread j havia sido iniciada anteriormente');

        DG_FEATURE_NOT_SUPPORTED:
          MostraStatus(j,'Comando enviado para uma placa FXO e no E1');

        DG_ERROR_FIFO_UNAVAILABLE:
          MostraStatus(j,'Erro na criao da estrutura de comunicao da thread');

        DG_ERROR_COULD_NOT_CREATE_THREAD:
          MostraStatus(j,'Falha na inicializao da thread');

      end;
    end;

    for i:=1 to voicerlib1.GetCardsCount do
    begin
      //Configura o sincronismo
      voicerlib1.SetCardSyncMode(i, SYNC_LINE_A);
      //Configura para que o evento OnE1Alarm ocorra automaticamente sempre quando um alarme for detectado
      voicerlib1.SetAlarmMode(i, ALARM_AUTOMATIC_NOTIFY);
    end;

    for k:=1 to voicerlib1.GetPortsCount do
    begin
      //Categoria do Assinante
      voicerlib1.ConfigE1Thread(k, E1CFG_GROUP_II,1);
      //Seta o Bina
      voicerlib1.SetPortID(k, '1121916363');
      //Numero total de digitos a receber
      voicerlib1.ConfigE1Thread(k, E1CFG_MAXDIGITS_RX,4);
      //Status Grupo B
      voicerlib1.ConfigE1Thread(k, E1CFG_GROUP_B,1);
      //Em ligacoes de entrada, pede bina apos o 2 digito
      voicerlib1.ConfigE1Thread(k, E1CFG_SEND_ID_AFTERDIGIT,2);
    end;

  except
    Application.MessageBox('Erro na Criao das Threads E1', 'Except', mb_OK);
  end;
end;

//**********************************************************
//Destroi as threads de tratamento E1 de cada canal da placa
//**********************************************************
procedure TForm1.DestroiThreadClick(Sender: TObject);
var
  nRet,i : Integer;
begin
  try
    //Desabilita amostras de audio
    nRet := voicerLib1.DisableInputBuffer(StrToInt(txtPorta.Text));
    case nRet of
      DG_EXIT_SUCCESS:
        MostraStatus(StrToInt(txtPorta.Text),'InputBuffer desabilitado com sucesso');
      DG_ERROR_DRIVER_CLOSED:
        MostraStatus(StrToInt(txtPorta.Text),'DisableInputBuffer -> Driver desabilitado');
      DG_ERROR_PORT_OUT_OF_RANGE:
        MostraStatus(StrToInt(txtPorta.Text),'DisableInputBuffer -> Parmetro porta fora do intervalo permitido, excedendo o nmero de portas instaladas');
      else
        MostraStatus(StrToInt(txtPorta.Text),'Gerou excessao no DisableInputBuffer');
    end;

    for i:=1 to voicerlib1.GetPortsCount do
    begin
      //Destroi as Threads
      if voicerlib1.DestroyE1Thread(i) <> DG_EXIT_SUCCESS then
        MostraStatus(i,'Erro ao destruir Thread E1')
      else
        MostraStatus(i,'Fechou Thread E1') ;
    end;

    txtPorta.Enabled := True;

  except
    Application.MessageBox('Erro ao Destruir as Threads E1', 'Except', mb_OK);
  end;
end;

//*********************************************
//Limpa tela de Log
//*********************************************
procedure TForm1.LimpaLogClick(Sender: TObject);
begin
  Memo1.Clear;
end;

//***********************************************
// Inicia VoicerLib
//***********************************************
procedure TForm1.cmdIniciaDriverClick(Sender: TObject);
var
  nRet, nRet1, i:Integer;
begin
  nFlag := 0 ;

  if voicerlib1.DriverEnabled then
    MostraStatus(0,'Driver ja inicializado')
  else
  begin
    //Inicializa a placa
    nRet := voicerlib1.StartVoicerLib;
    //Trata o retorno da inicializacao
    voicerlib1.ReturnCodeToString(nRet,Cardinal(@sReturn));    

    //Testa o retorno do StartVoicerLib
    if nRet = DG_EXIT_SUCCESS then
    begin
      MostraStatus(0,'VoicerLib Inicializada com Sucesso');
      nTotalPortas := voicerlib1.GetPortsCount ;
      nTotalPlacas := voicerlib1.GetCardsCount ;
      lblStatus.Caption := 'Nmero Total de Placas: ' + IntToStr(nTotalPlacas) ;
      lblStatus1.Caption := 'Nmero Total de Portas: ' + IntToStr(nTotalPortas) ;
      cmdIniciaDriver.Enabled := False ;
      cmdFinalizaDriver.Enabled := True;
      txtPorta.Enabled := False;

      for i := 1 to voicerlib1.GetPortsCount do
      begin
        //Permite alterar o limiar para deteco de atendimento
        voicerlib1.SetSilenceThreshold(i,StrToInt(txtLimiar.Text));
        nRet1 := voicerlib1.CreateCallProgress(i,'cp_default.cfg');
        if nRet1 <> DG_EXIT_SUCCESS then
          MostraStatus(i,'Erro ao executar Superviso de Linha CreateCallProgress.Ret.:' + IntToStr(nRet));
      end;
    end
    else
      MostraStatus(0,'Erro ao iniciar a voicerlib -> ' + sReturn); 

  end;
end;

//*********************************************
//Finaliza VoicerLib
//*********************************************
procedure TForm1.cmdFinalizaDriverClick(Sender: TObject);
var
  ret,i : integer;
begin

  if VoicerLib1.DriverEnabled then
  begin
    for i:=1 to voicerlib1.GetPortsCount do
    begin
      //Finaliza a supervisao de linha
      voicerlib1.DestroyCallProgress(i);
    end;

    //Desabilita a deteccao de silencio
    voicerlib1.DisableSilenceDetection(StrToInt(txtPorta.Text));

    //Desliga a Placa
    ret:= voicerlib1.ShutdownVoicerLib;
    //Testa se desligou corretamente
    if ret <> DG_EXIT_SUCCESS then
      MostraStatus(0,'Erro na finalizao. Recomenda-se reiniciar o micro')
    else
    begin
      MostraStatus(0,'Placa finalizada com sucesso');
      cmdIniciaDriver.Enabled := True;
      cmdFinalizaDriver.Enabled := False;
      txtPorta.Enabled := True;
    end;
  end;
end;

//******************************************************
// Recebe Ring e atende chamada - Aguarda Evento OnAfterPickup
//******************************************************
procedure TForm1.voicerlib1RingDetected(ASender: TObject; Port: Smallint);
begin
  try
    //Atende a Ligacao
    voicerlib1.PickUp(Port,1000);
    MostraStatus(Port,'Atendeu a chamada...');
  except
    Application.MessageBox('Erro ao Atender chamada', 'Except', mb_OK);
  end;
end;

//**************************************
// Reproduz mensagem - Aguarda PlayStop
//**************************************
procedure TForm1.voicerlib1AfterPickup(ASender: TObject; Port: Smallint);
var
  sArq : string;
begin
  try
    sArq :=extractFilePath(Application.exename) + 'Fraseatendimento.wav';
    //Reproduz mensagem de atendimento
    if VoicerLib1.PlayFile(Port,sArq,'567',0) = DG_EXIT_SUCCESS then
      MostraStatus(Port,'Reproduzindo mensagem ' + sArq)
    else
    begin
      MostraStatus(Port,'Arquivo '+ sArq + ' no encontrado...');
      //Desliga
      VoicerLib1.HangUp(Port);
      MostraStatus(Port,'Desligou...');
      voicerlib1.DisableCallProgress(Port);
      voicerlib1.DisableSilenceDetection(Port);
    end;

  except
    Application.MessageBox('Erro em AfterPickup', 'Except', mb_OK);
  end;
end;

//*********************************************
//Este evento  gerado aps o trmino de uma
//reproduo de frase
//*********************************************
procedure TForm1.voicerlib1PlayStop (ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet : Integer;
begin
  if StopStatus = ssNormal then
  begin
    //Especifica o formato de gravacao
    VoicerLib1.SetRecordFormat(Port,ffWaveULaw);

    nRet := voicerlib1.EnableCallProgress(Port,CP_ENABLE_BUSY_OR_FAX);
    if nRet <> DG_EXIT_SUCCESS then
      MostraStatus(Port,'OnPlayStop -> Erro ao habilitar superviso de linha.nRet.:' + IntToStr(nRet))
    else
      MostraStatus(Port,'OnPlayStop -> Habilitou superviso de linha com sucesso');

    //Habilita o envio de amostras da placa para a aplicao
    voicerlib1.EnableInputBuffer(Port,DG_ENABLE);
    nFlag := 0 ;

    //Desabilita o tempo de silencio caso esteja habilitado em testes seguidos
    voicerlib1.DisableSilenceDetection(Port);
    //Habilita deteccao de silencio
    voicerlib1.EnableSilenceDetection(Port,StrToInt(txtTempoSilencio.Text),100);

    //Inicia Gravao de Recado
    VoicerLib1.RecordFile(Port,extractFilePath(Application.exename) +'gravacao.wav','');
    MostraStatus(Port,'Gravando Mensagem em ' + extractFilePath(Application.exename) +'gravacao.wav');
  end;
end;

//*************************************************
//este evento  gerado logo aps se mandar parar
//uma gravao
//*************************************************
procedure TForm1.voicerlib1RecordStop(ASender: TObject; Port,
  StopStatus: Smallint);
var
  nRet : Integer;

begin
  //Desabilita as amostras de audio
  nRet := voicerlib1.DisableInputBuffer(Port);
  case nRet of
    DG_EXIT_SUCCESS:
      MostraStatus(Port,'OnRecordStop -> InputBuffer desabilitado com sucesso');
    DG_ERROR_DRIVER_CLOSED:
      MostraStatus(Port,'OnRecordStop -> DisableInputBuffer -> Driver desabilitado');
    DG_ERROR_PORT_OUT_OF_RANGE:
      MostraStatus(Port,'OnRecordStop -> DisableInputBuffer -> Parmetro porta fora do intervalo permitido, excedendo o nmero de portas instaladas');
    else
      MostraStatus(Port,'OnRecordStop -> Gerou excessao no DisableInputBuffer');
  end;

  //Desliga
  VoicerLib1.HangUp(Port);
  MostraStatus(Port,'OnRecordStop -> Desligou...');
  voicerlib1.DisableCallProgress(Port);
  voicerlib1.DisableSilenceDetection(Port);
  
end;

//**********************************************************
//No desligamento do assinante chamador a VoicerLib
//gera um evento Onbusy que deve ser utilizado para parar
//a gravao
//**********************************************************
procedure TForm1.voicerlib1BusyDetected(ASender: TObject; Port: Smallint);
begin
  //testa se esta falando a mensagem inicial
  if voicerlib1.IsPlaying(Port) then
  begin
    //para de falar a frase
    voicerlib1.StopPlayFile(Port);
    MostraStatus(Port,'Assinante A desligou...Parando a frase...');
   //Desliga a porta
    VoicerLib1.HangUp(Port);
    MostraStatus(Port,'Desligou...');
    voicerlib1.DisableCallProgress(Port);
    voicerlib1.DisableSilenceDetection(Port);
  end
  else
  //testa se ainda est gravando
  if voicerlib1.IsRecording(Port) then
  begin
    //Pra a gravacao
    VoicerLib1.StopRecordFile(Port);
    MostraStatus(Port,'Assinante A desligou...Parando a gravacao...');
  end;
end;


//*********************************************
//Durante a gravao a VoicerLib envia a cada
//segundo este evento com o tempo de gravao
//*********************************************
procedure TForm1.voicerlib1Recording(ASender: TObject; Port: Smallint;
  ElapsedTime: Integer);
var
  nMaxRecTime, nRet: integer;
begin
  //le tempo mximo de gravao
  nMaxRecTime := strToInt(Edit2.text);

  //testa se atingiu limite
  if (ElapsedTime >= nMaxRecTime) and (nFlag = 0)then
  begin
    nFlag := 1;
    //Pra a gravacao
    VoicerLib1.StopRecordFile(Port);
    MostraStatus(Port,'Parando a gravacao por tempo mximo');
    //Desliga Porta
    voicerlib1.HangUp(port);
    MostraStatus(Port,'OnRecording -> Desligou...');
    voicerlib1.DisableCallProgress(Port);
    voicerlib1.DisableSilenceDetection(Port);
    
    //Desabilita as amostras de audio
    nRet := voicerlib1.DisableInputBuffer(Port);
    case nRet of
      DG_EXIT_SUCCESS:
        MostraStatus(Port,'InputBuffer desabilitado com sucesso');
      DG_ERROR_DRIVER_CLOSED:
        MostraStatus(Port,'DisableInputBuffer -> Driver desabilitado');
      DG_ERROR_PORT_OUT_OF_RANGE:
        MostraStatus(Port,'DisableInputBuffer -> Parmetro porta fora do intervalo permitido, excedendo o nmero de portas instaladas');
      else
        MostraStatus(Port,'Gerou excessao no DisableInputBuffer');
    end;

  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  //Verifica se o driver esta inicializado
  if VoicerLib1.DriverEnabled then
  begin
    Application.Messagebox('Finalize a VoicerLib antes de fechar a aplicao','Aviso',MB_OK + MB_ICONSTOP);
    CanClose := false;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  L:String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt';
  ShellExecute(0 ,nil,PChar(L), nil, nil,SW_NORMAL);
end;


//*********************************************
//mostra na tela o nmero do assinante A(Bina)
//*********************************************

procedure TForm1.voicerlib1CallerID(ASender: TObject; Port: Smallint;
  const Number: WideString);

begin
  Edit1.Text := Number;
end;

procedure TForm1.voicerlib1E1Alarm(ASender: TObject; Card, E1Id, AlarmCode,
  AlarmData: Smallint);
begin
  case AlarmCode of
    ALARM_RSLIP:
      MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Escorregamento (problema de sincronismo) - ' + IntToStr(AlarmCode));

    ALARM_RAIS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Alarme remoto ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Alarme remoto OFF');
    end;

    ALARM_AISS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme OFF');
    end;

    ALARM_AIS16S:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Indicao de alarme canal 16 OFF');
    end;

    ALARM_LOSS:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Perda de sinal ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Perda de sinal OFF');
    end;

    ALARM_RESERVED:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Reservado ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Reservado OFF');
    end;

    ALARM_MFSYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de multiquadro OFF');
    end;

    ALARM_SYNC:
    begin
      if AlarmData = 1 then
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro ON')
      else
        MostraStatus(0,'Placa ' + IntToStr(Card)+ ' ->Sincronismo de quadro OFF');
    end;
  end;
end;

procedure TForm1.voicerlib1E1StateChange(ASender: TObject; Port,
  State: Smallint);
begin
  case State of
    C_SEIZURE:
      MostraStatus(Port,'E1 Ocupao');

    C_NUMBER_RECEIVED:
      MostraStatus(Port,'E1 Nmero Recebido -> ' + voicerlib1.GetE1Number(Port));

    C_CONGESTION:
      MostraStatus(Port,'E1 Congestionamento');

    C_B_ENDCALL:
       MostraStatus(Port,'E1 Fim da Chamada');

    C_NOTCOMPLETED:
       MostraStatus(Port,'E1 No completada');

    C_GROUP_II:
       MostraStatus(Port,'E1 Categoria');

    C_UNAVAILABLE:
       MostraStatus(Port,'E1 No disponvel');

    else
      MostraStatus(Port,'E1 State -> ' + IntToStr(State));
  end;
end;

procedure TForm1.voicerlib1SilenceDetected(ASender: TObject; Port,
  State: Smallint);
begin
  //Verifica se detectou silencio, se sim desliga
  if State = DG_SILENCE_DETECTED then
  begin
    MostraStatus(Port,'Silencio');
    VoicerLib1.HangUp(Port);
    MostraStatus(Port,'Desligou...');
    voicerlib1.DisableCallProgress(Port);
    voicerlib1.DisableSilenceDetection(Port);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  nRet : Integer;
  cVersao : array[0..255] of Char;
begin

  //Verifica a versao da dll e ocx da voicerlib
  nRet := voicerlib1.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL -> ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := voicerlib1.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');

end;

end.
